﻿@model ExploreApilkasiCuti.Models.PengajuanDOL
@{
    ViewBag.Title = "Detail";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

@section HeadLibrary{
    <!-- Ionicons -->
    <link rel="stylesheet" href="https://code.ionicframework.com/ionicons/2.0.1/css/ionicons.min.css">
    <!-- DataTables -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
    <link rel="stylesheet" href="~/AdminLTE/plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
    <!-- Toast-->
    <link rel="stylesheet" href="~/AdminLTE/plugins/sweetalert2-theme-bootstrap-4/bootstrap-4.min.css" />
    <link rel="stylesheet" href="~/AdminLTE/plugins/toastr/toastr.min.css" />
    <!-- Theme style -->
    <link rel="stylesheet" href="~/AdminLTE/dist/css/adminlte.min.css">
    <!-- Datepicker-->
    <link rel="stylesheet" href="~/AdminLTE/plugins/bootstrap-datepicker/css/bootstrap-datepicker.min.css">
    <!-- Google Font: Source Sans Pro -->
    @*    <link href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700" rel="stylesheet">
    *@    <!-- Select2 -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/select2/css/select2.min.css">
    <link rel="stylesheet" href="~/AdminLTE/plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
}
<style>
    .help-block {
        color: red;
    }
</style>
<div class="card">
    <div class="card-header">
        <h2>@ViewBag.Title</h2>
    </div>
    <div class="card-body">
        <div class="col-sm-12">
            <div class="row justify-content-between">
                <a href="@Url.Action("Index", "PengajuanDOL")" class="btn btn-default">
                    <i class="nav-icon fas fa-chevron-left"></i>   Kembali
                </a>
                @*<button type="button" class="btn btn-default" onclick="show_modal_insertupdate('ADD')">
                        <i class="nav-icon fas fa-chevron-left"></i>   Kembali
                    </button>*@
                @*<button type="button" id="buttonSubmit" class="btn btn-default" onclick="submitData()">
                        <i class="nav-icon fas fa-save"></i>   Submit Data
                    </button>*@
                <div class="mt-3 col-md-12"></div>
            </div>
        </div>
        <div class="row">
            <div class="col-sm-12">
                <div class="card card-primary card-outline card-outline-tabs">
                    <div class="card-body">
                                <!--<div class="card card-primary">-->
                                <form role="form" id="form-header">
                                    <div class="card-body">
                                        <div class="row">
                                            <div class="col-12 col-sm-6">
                                                <div class="invisible" id="IdPengajuan"></div>
                                                <div class="form-group">
                                                    <label class="err-jenisCuti control-label">Jenis Cuti</label>
                                                    <select name="JenisCuti" id="JenisCuti" class="form-control select2 JenisCuti" style="width: 100%;">
                                                    </select>
                                                    <span id="spanJenisCuti" class="err-jenisCuti help-block"></span>
                                                </div>
                                                <div class="form-group">
                                                    <div class="row">
                                                        <div class="col-12 col-sm-6">
                                                            <label class="control-label" style="padding-right:1em" id="labelDatepicker">Pilih Tanggal Cuti</label>
                                                            <div class="input-group date form-group" id="datepicker">
                                                                <input type="text" class="form-control" id="LeaveDatePicker" name="LeaveDatePicker" placeholder="Select days" hidden />
                                                                @*<span class="input-group-addon"><i class="fa fa-calendar"></i><span class="count"></span></span>*@
                                                                <span class="btn btn-sm btn-icon btn-icon rounded-circle bg-gradient-secondary waves-effect waves-light"><i class="fa fa-calendar"></i></span>
                                                                <span id="span_tanggal" class="help-block"></span>
                                                            </div>
                                                        </div>
                                                        <div class="col-12 col-sm-6">
                                                            <label class="control-label" id="totalDurasi" style="padding-right:1em">Total Durasi</label>
                                                            <input class="form-control" id="totalDurasiInput" type="text" readonly>
                                                        </div>
                                                        <span id="span_leave_half_day" class="help-block"></span>
                                                    </div>
                                                </div>
                                                <div class="form-group">
                                                    <label class="control-label">Keterangan</label>
                                                    <textarea name="Keterangan" placeholder="Enter ..." id="Keterangan" class="form-control" type="text" rows="3"></textarea>
                                                    <span id="span_keterangan" class="help-block"></span>
                                                </div>
                                                <div class="form-group" id="sendToApproval">
                                                    <label class="control-label">Kirim Ke</label>
                                                    <div class="grid" style="width:100%" id="gridSendToApproval">
                                                        <div class="form-group" style="width:100%">
                                                            @*<label class="err-idApproval control-label">ID Approval</label>*@
                                                            <select name="IDApproval" id="IDApproval" class="form-control select2 IDApproval" style="width: 100%;">
                                                            </select>
                                                            <span id="spanIdApproval" class="err-idApproval help-block"></span>
                                                        </div>
                                                        <div class="form-group" style="width:100%">
                                                            @*<label class="err-idKywApproval control-label">ID Karyawan Approval</label>*@
                                                            <select name="IDKywApproval" id="IDKywApproval" class="form-control select2 IDKywApproval" style="width: 100%;">
                                                            </select>
                                                            <span id="spanIdKywApproval" class="err-idKywApproval help-block"></span>
                                                        </div>
                                                    </div>
                                                </div>
                                                <div class="form-group">
                                                    <label for="customFile" class="control-label" id="labelUploadFile">Attachment</label>
                                                    <div class="row">
                                                        <div class="custom-file col-12 col-sm-10">
                                                            <input type="file" class="custom-file-input" id="file" name="file">
                                                            <label class="custom-file-label " for="customFile">Pilih File</label>
                                                        </div>
                                                        <div class="col-12 col-sm-2">
                                                            <button type="button" class="btn btn-default" onclick="RemoveFile()" id="btnRemovefile">
                                                                <i class="nav-icon fas fa-times-circle"></i>
                                                            </button>
                                                        </div>
                                                    </div>
                                                    <span class="help-block" id="spanfile"></span>
                                                </div>
                                                <div class="form-group" id="saveFile">
                                                        <label class="control-label">Attachment</label>
                                                        <div></div>
                                                        <input name="nama_file" placeholder="Tidak Ada" id="nama_file" type="text" style="width:300px" disabled>
                                                        <button type="button" class="btn btn-default" onclick="saveFile()" id="btnSaveFile">
                                                            <i class="nav-icon fas fa-save"></i>   Download
                                                        </button>
                                                </div>
                                            </div>
                                            <div class="col-12 col-sm-6">
                                                <div class="form-group" id="approvalDetail">
                                                    <label class="control-label">History Approval</label>
                                                    <!-- The timeline -->
                                                    <div class="timeline timeline-inverse" id="historyApproval">
                                                
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </form>
                                <!--</div>-->
                    </div>
                    <div class="card-footer">
                        <button type="button" id="buttonSubmit" class="btn btn-default" onclick="submitData()">
                            <i class="nav-icon fas fa-save"></i>   Submit Data
                        </button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<div class="modal fade" id="modal_form_insertupdatedetail" role="dialog" data-keyboard="true" data-backdrop="static">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
            <div class="modal-header">
                <h3 class="modal-title" id="insertUpdateDetailModal">Tambah Tanggal Cuti</h3>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
            </div>
            <div class="card card-primary">
                <form role="form" id="form-insertupdatedetail">
                    <div class="card-body">
                        <div class="form-group">
                            <div class="invisible" id="Id"></div>
                            <label>Tanggal Mulai Cuti</label>
                            <div class="input-group date" data-target-input="nearest" id="StartDate">
                                <input type="text" class="form-control datetimepicker-input" id="StartDate" data-target="#StartDate" data-date-format="DD-MM-YYYY" required />
                                <div class="input-group-append" id="StartDate" data-target="#StartDate" data-toggle="datetimepicker">
                                    <div class="input-group-text" id="StartDate" placeholder="Masukkan Tanggal Mulai"><i class="fa fa-calendar"></i></div>
                                </div>
                            </div>
                            <span id="span_start_date" class="help-block"></span>
                        </div>
                        <div class="form-group">
                            <label>Tanggal Selesai Cuti</label>
                            <div class="input-group date" data-target-input="nearest" id="EndDate">
                                <input type="text" class="form-control datetimepicker-input" id="EndDate" data-target="#EndDate" data-date-format="DD-MM-YYYY" required />
                                <div class="input-group-append" id="EndDate" data-target="#EndDate" data-toggle="datetimepicker">
                                    <div class="input-group-text" id="EndDate" placeholder="Masukkan Tanggal Selasai"><i class="fa fa-calendar"></i></div>
                                </div>
                            </div>
                            <span id="span_end_date" class="help-block"></span>
                        </div>
                        <div class="form-group">
                            <label class="control-label">Waktu</label>
                            <input name="WaktuDetail" placeholder="Waktu" id="WaktuDetail" class="form-control" type="number" required>
                            <span id="span_waktu_detail" class="help-block"></span>
                        </div>

                        @*<label class="col-md-12" style="color:red">*Klik Tab untuk pindah field.</label>*@
                    </div>
                    <div class="card-footer d-flex">
                        <button type="button" onclick="btnSaveAddUpdate()" class="btn btn-primary mx-auto" style="width:35%">Simpan</button>
                        <button type="button" class="btn btn-danger mx-auto" data-dismiss="modal" style="width:35%">Batalkan</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>

@section BodyLibrary{
    <!-- DataTables -->
    <script src="@Url.Content("~/AdminLTE/plugins/datatables/jquery.dataTables.min.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/datatables-bs4/js/dataTables.bootstrap4.min.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/datatables-responsive/js/dataTables.responsive.min.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/datatables-responsive/js/responsive.bootstrap4.min.js")"></script>
    <!-- SweetAlert2 -->
    <script src="@Url.Content("~/AdminLTE/plugins/sweetalert2/sweetalert2.min.js")"></script>
    <!-- Toastr -->
    <script src="@Url.Content("~/AdminLTE/plugins/toastr/toastr.min.js")"></script>
    <!-- DataRender -->
    <script src="@Url.Content("~/AdminLTE/plugins/dataRender/dateTime.js")"></script>
    <!-- Select2 -->
    <script src="@Url.Content("~/AdminLTE/plugins/select2/js/select2.full.min.js")"></script>
     <!-- DataRender -->
    <script src="@Url.Content("~/AdminLTE/plugins/dataRender/dateTime.js")"></script>
    <!-- Datepicker -->
    <script src="~/AdminLTE/plugins/bootstrap-datepicker/js/bootstrap-datepicker.min.js"></script>
}

@section AdditionalScript{
    <script type="text/javascript">
        var destination = '@ViewBag.Action';
        var tempId = '@Session["id_karyawan"]';
        var Obj = {};
        var ListObj = [];
        var listDateCollection = [];
        var listPengajuanDetailDOL;
        var IdApproval;
        var tglPengajuan;
        var GroupID = '@Session["AccountGroupName"]';
        var id_Pengajuan = "";
        var filesize = "";
        var detailLinkFile = "";

        jQuery(document).ready(function ($) {
            loadDataSelect2();
            unselect_select2();
            bsCustomFileInput.init();
            $(function () {
                $("#file").change(function () {
                    checkfile();
                });
            });
            $("#Waktu").attr('readonly', true);
            $("#NamaKaryawan").attr('readonly', true);
            $("#TglPengajuan").attr('readonly', true);
            if (destination == 'Edit' || destination == 'Detail') {
                detailLinkFile = "";
                $("#sendToApproval").hide();
                $("#approvalDetail").show();
                $("#saveFile").show();
                $(".card-footer").hide();
                $(".custom-file").hide();
                $("#btnRemovefile").hide();
                $("#labelUploadFile").hide();
                $("#removefile").hide();
                $.ajax({
                    contentType: 'application/JSON; charset=utf-8',
                    url: '@Url.Action("GetDataDetailPengajuan", "PengajuanDOL")',
                    type: 'POST',
                    data: JSON.stringify({ "id": '@ViewBag.Id' }),
                    beforeSend: function () {
                        Swal.fire({
                            title: 'Processing...',
                            html: "Get Data.",
                            allowOutsideClick: false,
                            onBeforeOpen: () => {
                                Swal.showLoading()
                            }
                        });
                    },
                    success: function (data) {
                        Swal.close();
                        if (data.response.Code == '200') {
                            successInitData(data['data']);
                        } else {
                            toastr.warning('Gagal memuat data', 'Sorry!', { "timeOut": 5000 });
                        }
                    },
                    error: function (eventError, textStatus, errorThrown) {
                        toastr.error('Gagal memuat data', 'Failed!', { "timeOut": 5000 });
                    }
                });
            } else {
                enableDisableTextInput(false);
                getNamaKaryawanById();
                setTanggalPengajuan();
                $("#sendToApproval").show();
                $("#approvalDetail").hide();
                $("#saveFile").hide();
                $(".custom-file").show();
                $("#btnRemovefile").show();
                $(".card-footer").show();
                $(document).ready(function () {
                    $('#datepicker').datepicker({
                        multidate: true,
                        format: "yyyy-mm-dd",
                        todayHighlight: true
                    }).on('changeDate', function (e) {
                        var factor = $("#JenisCuti").val() == "DL_01" ? 1 : 0.5;
                        listDateCollection = $("#LeaveDatePicker").val().split(",");
                        $("#totalDurasiInput").val(listDateCollection.filter(item => item).length * factor + " hari");
                    });
                    $('#datepicker').datepicker('setStartDate', new Date());
                });
            }
        });

        function successInitData(data) {
            //getNamaKaryawanById();
            $('#IdPengajuan').val(data[0].id_pengajuan);
            $("#JenisCuti").empty().append($("<option/>").val(data[0].id_jenis_pengajuan).text(data[0].nama_pengajuan)).val(data[0].id_jenis_pengajuan);
            //$('#TglPengajuan').val(moment(data.tgl_pengajuan).format("DD-MM-YYYY"));
            //$('#TglPengajuan').attr('readonly', true);

            if (destination == 'Edit') {
                enableDisableTextInput(false);
                $("#Keterangan").val(data[0].keterangan_pengajuan);
            } else if (destination == 'Detail') {
                enableDisableTextInput(true);
                //getDataApproval(data.id_pengajuan);
                $("#Keterangan").val(data[0].keterangan_pengajuan);
                $("#totalDurasiInput").val(data[0].durasi + " hari");
                $("#IDApproval").empty().append($("<option/>").val(data[0].id_approval).text(data[0].nama_approval)).val(data[0].id_approval);
                $("#IDKywApproval").empty().append($("<option/>").val(data[0].approved_by).text(data[0].nama_karyawan_approval)).val(data[0].approved_by);
                $(document).ready(function () {
                    $('#datepicker').datepicker({
                        multidate: true,
                        format: "yyyy-mm-dd",
                        todayHighlight: true,
                        beforeShowDay: function () {
                            return false;
                        }
                    });
                    $('#datepicker').datepicker('setStartDate', new Date());
                });
                $("#nama_file").val(data[0].nama_file);
                if ($("#nama_file").val() == '') {
                    $("#btnSaveFile").prop('disabled', true);
                }
                
                detailLinkFile = data[0].link_file;
            }
            getListDetail(data[0].id_pengajuan);
            loadDataLogApprovalElm(data[0].id_pengajuan);
        }

        function enableDisableTextInput(enables) {
            $("#JenisCuti").prop('disabled', enables);
            $("#Keterangan").attr('readonly', enables);
            $("#IDApproval").prop('disabled', enables);
            $("#IDKywApproval").prop('disabled', enables);
            if (enables==true) {
                document.getElementById('buttonSubmit').style.visibility = 'hidden';
            }

        }

        function loadDataLogApprovalElm(rowId) {
            $.ajax({
                contentType: 'application/JSON; charset=utf-8',
                url: '@Url.Action("GetSpecificDataLogAppReturnElm", "MasterLogApproval")',
                type: 'POST',
                data: JSON.stringify({ "idPengajuan": rowId }),
                success: function (data) {
                    if (data.response.Code == '200') {
                        $("#historyApproval").append(data['data']);
                    } else {
                        toastr.warning('Gagal memuat data History Approval', 'Sorry!', { 'timeOut': 5000 });
                    }
                },
                error: function (eventError, textStatus, errorThrown) {
                    toastr.error('Gagal memuat data', 'Failed!', { "timeOut": 5000 });
                }
            });
        }


        function getDataJenisCutiById(rowId) {
            $.ajax({
                contentType: 'application/JSON; charset=utf-8',
                url: '@Url.Action("GetDataByID", "MasterJenisPengajuan")',
                type: 'POST',
                data: JSON.stringify({ "id": rowId}),
                success: function (data) {
                    Swal.close();
                    if (data.metaData.code == '200') {
                        $("#JenisCuti").empty().append($("<option/>").val(data.response[0].id_jenis_pengajuan).text(data.response[0].nama_pengajuan)).val(data.response[0].id_jenis_pengajuan);
                    } else {
                        var s = "<option value='-1'></option>";
                        $("#JenisCuti").html(s);
                    }
                },
                error: function (eventError, textStatus, errorThrown) {
                    toastr.error('Gagal memuat data', 'Failed!', { "timeOut": 5000 });
                }
            });
        }

        function setTanggalPengajuan() {
             $.ajax({
                    contentType: 'application/JSON; charset=utf-8',
                    url: '@Url.Action("GetDateNow", "PengajuanDOL")',
                    type: 'GET',
                    success: function (data) {
                        Swal.close();
                        if (data.metaData.code == '200') {
                            tglPengajuan = data.response.toString().substring(1,11);
                        } else {
                            toastr.warning('Gagal memuat data', 'Sorry!', { "timeOut": 5000 });
                        }
                    },
                    error: function (eventError, textStatus, errorThrown) {
                        toastr.error('Gagal memuat data', 'Failed!', { "timeOut": 5000 });
                    }
                });
        }

        function show_modal_insertupdatedetail(action) {
            save_method = action;
            if (action == 'ADD') {
                $('.form-group').removeClass('has-error');
                $('.help.block').empty();
                $("#insertUpdateDetailModal").text("Tambah Tanggal Cuti");
            } else if (action == 'EDIT') {
                $("#insertUpdateDetailModal").text("Ubah Tanggal Cuti");
            }
            $("#modal_form_insertupdatedetail").modal('show');
        }

        function unselect_select2() {


            var newOption = new Option("", "", true, true);
            var newOption2 = new Option("", "", true, true);
            // Append it to the select
            $('#JenisCuti').append(newOption).trigger('change');
            $('#IDApproval').append(newOption2).trigger('change');

        }
        function loadDataSelect2() {
            var idApproval = "";
            var listDetailPct = [];


            $.ajax({
                url: '@Url.Action("GetDatatableAll", "MasterJenisPengajuan")',
                type: 'POST',
                dataType: 'json',
                delay: 250,
                processResults: function (data) {
                    return {
                         results: $.map(data['data'], function (item) {
                                if (item.id_jenis_pengajuan.toUpperCase().includes('DL')|| item.id_jenis_pengajuan.toUpperCase().includes('DOL')) {
                                    return {
                                        text: item.nama_pengajuan,
                                        id: item.id_jenis_pengajuan
                                    }
                                }
                            })
                    };
                }
            }).then(
                function (response) {
                    $('#JenisCuti').select2({
                        multiple: false,
                        allowClear: true,
                        placeholder: '- Pilih Jenis Cuti -',
                        width: '100%',
                        theme: 'bootstrap4',
                        data: $.map(response.data, function (item) {
                            if (item.id_jenis_pengajuan.toUpperCase().includes('DL') || item.id_jenis_pengajuan.toUpperCase().includes('DOL')) {
                                return {
                                    text: item.nama_pengajuan,
                                    id: item.id_jenis_pengajuan
                                }
                            }
                        })
                    });
                }
            );

            $.ajax({
                url: '@Url.Action("GetDatatableAll", "MasterApproval")',
                type: 'POST',
                dataType: 'json',
                delay: 250,
                processResults: function (data) {
                    return {
                        results: $.map(data['data'], function (item) {
                            if (GroupID.toUpperCase().includes('STAFF')) {
                                if (!item.id_approval.toUpperCase().includes('HRD')) {
                                    if (item.status == "Aktif") {
                                        return {
                                            text: item.nama_approval,
                                            id: item.id_approval
                                        }
                                    }
                                }

                            } else {
                                if (item.status == "Aktif") {
                                    return {
                                        text: item.nama_approval,
                                        id: item.id_approval
                                    }
                                }
                            }
                        })
                    };
                }
            }).then(
                function (response) {
                    $('#IDApproval').select2({
                        multiple: false,
                        allowClear: true,
                        placeholder: '- Pilih ID Approval -',
                        width: '100%',
                        theme: 'bootstrap4',
                        data: $.map(response.data, function (item) {
                            if (GroupID.toUpperCase().includes('STAFF')) {
                                if (!item.id_approval.toUpperCase().includes('HRD')) {
                                    if (item.status == "Aktif") {
                                        return {
                                            text: item.nama_approval,
                                            id: item.id_approval
                                        }
                                    }
                                }

                            } else {
                                if (item.status == "Aktif") {
                                    return {
                                        text: item.nama_approval,
                                        id: item.id_approval
                                    }
                                }
                            }
                        })
                    });
                }
            );

            $('#IDApproval').on('select2:select', function (e) {
                var idApproval = {
                    "id": $("#IDApproval option:selected").val()
                };
                $('#IDKywApproval').empty();
                $.ajax({
                    contentType: 'application/JSON; charset=utf-8',
                    url: '@Url.Action("GetDataByIdApproval", "MasterKaryawanApproval")',
                    data: JSON.stringify(idApproval),
                    type: 'POST',
                    dataType: 'json',
                    delay: 250,
                    processResults: function (data) {
                        return {
                            results: $.map(data['data'], function (item) {
                                return {
                                    text: item.nama,
                                    id: item.id_karyawan,
                                    data: item
                                }
                            })
                        };
                    }
                }).then(
                    function (response) {
                        $('#IDKywApproval').select2({
                            multiple: false,
                            allowClear: true,
                            placeholder: '- Pilih ID Karyawan Approval -',
                            width: '100%',
                            theme: 'bootstrap4',
                            data: $.map(response.data, function (item) {
                                    return {
                                        text: item.nama,
                                        id: item.id_karyawan,
                                        data: item
                                    }
                            })
                        });
                    }
                );

                var newOption = new Option("", "", true, true);
                $('#IDKywApproval').append(newOption).trigger('change');
            });

            $('#IDKywApproval').select2({
                multiple: false,
                allowClear: true,
                placeholder: '- Pilih ID Karyawan Approval -',
                width: '100%',
                theme: 'bootstrap4',
            });
            $('#IDApproval').select2({
                multiple: false,
                allowClear: true,
                placeholder: '- Pilih ID Approval -',
                width: '100%',
                theme: 'bootstrap4',
            });


            $('#IDApproval').on('select2:unselect', function () {
                $('#IDKywApproval').empty();
                $('#IDKywApproval').select2({
                    multiple: false,
                    allowClear: true,
                    placeholder: '- Pilih ID Karyawan Approval -',
                    width: '100%',
                    theme: 'bootstrap4',
                    data: null
                });
            })


        }

        $("#JenisCuti").on("select2:select", function (e) {
                var factor = $("#JenisCuti").val() == "DL_01" ? 1 : 0.5;
                if (listDateCollection.length > 0) {
                    $("#totalDurasiInput").val(listDateCollection.filter(item => item).length * factor);
                }
        });





        function getNamaKaryawanById() {
             $.ajax({
                contentType: 'application/JSON; charset=utf-8',
                url: '@Url.Action("GetDataByIdKaryawan", "MasterKaryawan")',
                type: 'POST',
                data: JSON.stringify({ "id": tempId }),
                success: function (data) {
                    Swal.close();
                    if (data.response.code == '200') {
                        $("#NamaKaryawan").val(data['data'][0].nama);
                    } else {
                        toastr.warning("Gagal memuat nama karyawan", "Sorry!", { "timeOut" : 5000});
                    }
                },
                error: function (eventError, textStatus, errorThrown) {
                    toastr.error("Gagal memuat data.", 'Failed!', { "timeOut": 5000 });
                }
             });
        }

        $('#dataPengajuanDOLDetail').dataTable({
            responsive: true,
            autoWidth: false,
            data: ListObj,
            columns: [
                { data: 'Id',render: function (data, type, full, meta) { return meta.row + 1; } },
                { data: 'StartDate', autoWitdh: true },
                { data: 'EndDate', autoWitdh: true },
                { data: 'WaktuDetail', autoWitdh: true },
                {
                    render: function (data, type, full, meta) {
                        return '<button type="button" data-toggle="modal" class="btn btn-sm btn-icon btn-icon rounded-circle bg-gradient-secondary waves-effect waves-light" style = "margin-right: 5px;" onclick = "editDetail(' + meta.row + ')" > <i class="fas fa-edit"></i></button >'+
                               '<button type="button" class="btn btn-sm btn-icon btn-icon rounded-circle bg-gradient-danger waves-effect waves-light" onclick="deleteDetail(' + meta.row + ')"><i class="fa fa-trash-alt"></i></button>'
                    }
                }
            ]
        });
        var table = $('#dataPengajuanDOLDetail').DataTable()


        function btnSaveAddUpdate() {
            var validate = true;
            $('.help-block').empty();

            if ($("#StartDate").find("input").val() == "") {
                $('#span_start_date').text('Start Date Harus diisi');
                validate = false;
            }
            if ($("#EndDate").find("input").val() == "") {
                $('#span_end_date').text('End Date Harus diisi');
                validate = false;
            }
            if ($('#WaktuDetail').val() == "") {
                $('#span_waktu_detail').text('Waktu Harus diisi');
                validate = false;
            }
            if (!validate) {
                return;
            }

            if (save_method == "ADD") {
                obj = {}
                obj.StartDate = $("#StartDate").find("input").val()
                obj.EndDate = $("#EndDate").find("input").val()
                obj.WaktuDetail = $('#WaktuDetail').val()

                ListObj.push(obj)
                table.clear()
                table.rows.add(ListObj)
                table.draw()
            } else if (save_method == "EDIT") {
                var data = table.row(rowData).data()

                obj.StartDate = $("#StartDate").find("input").val()
                obj.EndDate = $("#EndDate").find("input").val()
                obj.WaktuDetail = $('#WaktuDetail').val()

                Class.update(ListObj, row => row.id == data.id, data)
                table.clear()
                table.rows.add(ListObj)
                table.draw()
            }
            $("#modal_form_insertupdatedetail").modal('hide');
            //setTotalWaktuHeader();

        }

        function deleteDetail(row) {
            Swal.fire({
                title: 'Perhatian',
                text: "Apakah anda Yakin menghapus data ini ?" ,
                type: 'warning',
                showCancelButton: true,
                confirmButtonColor: '#3085d6',
                cancelButtonColor: '#d33',
                confirmButtonText: 'Hapus Data',
                confirmButtonClass: 'btn btn-primary',
                cancelButtonClass: 'btn btn-danger ml-1',
                showLoaderOnConfirm: true,
                buttonsStyling: false,
                preConfirm: (delete_part) => {
                    var data = table.row(row).data()
                    Class.remove(ListObj, row => row.id === data.id)

                    table.clear()
                    table.rows.add(ListObj)
                    table.draw()
                    setTotalWaktuHeader();
                },
                allowOutsideClick: () => !Swal.isLoading()
            });
        }
        var rowData = -1
        function editDetail(row) {
            rowData = row
            var data = table.row(row).data()
            $('#StartDate').find("input").val(data.StartDate)
            $('#EndDate').find("input").val(data.EndDate)
            $('#WaktuDetail').val(data.WaktuDetail)
            save_method = "EDIT";
            $("#insertUpdateDetailModal").text("Ubah Tanggal Cuti");
            $('#modal_form_insertupdatedetail').modal('show')
        }

        $('#update').click(function () {
            var data = table.row(rowData).data()

            data.StartDate = $('#StartDate').find("input").val()
            data.EndDate = $('#EndDate').find("input").val()
            data.WaktuDetail = $('#WaktuDetail').val()

            Class.update(ListObj, row => row.id == data.id, data)
            table.clear()
            table.rows.add(ListObj)
            table.draw()
        })
        var Class = {

            //remove
            remove: function (array, predicate) {
                for (var j = 0; j < array.length; j++) {
                    if (predicate(array[j])) {
                        return array.splice(j, 1);
                    }
                }
            },
            update: function (array, predicate, obj) {
                for (var j = 0; j < array.length; j++) {
                    if (predicate(array[j])) {
                        return array.splice(j, 1, obj);
                    }
                }
            }
        }

        $('#modal_form_insertupdatedetail').on('hidden.bs.modal', function (e) {
            var date = new Date();
            var new_date = moment(date.setDate(date.getDate() + 1000)).format("YYYY-MM-DD");
            //toastr.warning(print, "Sorry!", { "timeOut": 5000 });
            //var date2 = new Date(new Date().setDate(new Date().getDate() + 5));
            //toastr.warning(date2, "Sorry!", { "timeOut": 5000 });
            //$("#StartDate").datepicker("option", "minDate", null);
            //$("#EndDate").datepicker("option", "minDate", null);
            //$("#StartDate").find("input").empty();
            //$("#EndDate").find("input").empty();
            //$("#StartDate").find("input").val('');
            //$("#EndDate").find("input").val('');
            //$('#StartDate').data().DateTimePicker.date(null);
            //$('#EndDate').data().DateTimePicker.date(null);
            //$('#EndDate').datetimepicker('minDate', new Date());
            //$('#EndDate').datetimepicker('maxDate', new Date());
            //$('#StartDate').datetimepicker('minDate', new Date());
            $('#StartDate').datetimepicker('maxDate', new Date(new_date));
            //$("#StartDate").find("input").empty();
            //$("#EndDate").find("input").empty();
            $(this)
                .find("input,textarea,select")
                .val('')
                .end()
                .find("input[type=checkbox], input[type=radio]")
                .prop("checked", "")
                .end();
        })

        function submitData() {
            var jsonObj = {};
            var detailArray = [];
            var validate = true;

            $('.help-block').empty();
            if ($('#JenisCuti').val() == "") {
                $('#spanJenisCuti').text('Jenis Cuti Harus diisi');
                validate = false;
            }
            if ($('#Keterangan').val() == "") {
                $('#span_keterangan').text('Keterangan Harus diisi');
                validate = false;
            }
            if ($('#IDApproval').val() == "") {
                $('#spanIdApproval').text('Id Approval Harus diisi');
                validate = false;
            }
            if ($('#IDKywApproval').val() == "") {
                $('#spanIdKywApproval').text('Karyawan Approval Harus diisi');
                validate = false;
            }
            if (!listDateCollection.length) {
                $('#span_tanggal').text('Tanggal Cuti Harus diisi');
                //toastr.warning("Anda belum memilih Tanggal Cuti.", "Sorry!", { "timeOut": 5000 });
                validate = false;
            }
            if ($("#file").val() != "") {
                validate = checkfile();
            }

            @*if (ListObj.length == 0) {
                toastr.warning("Detail Pengajuan DOL Harus diisi", "Sorry!", { "timeOut": 5000 });
                validate = false;
            }*@
            if (!validate) {
                return;
            }
            var durasi = $("#JenisCuti").val() == "DL_02" ? 0.5 : 1;
            var totalDurasi = listDateCollection.length * durasi;
            //var totalDurasi = listDateCollection.length;
            jsonObj.tgl_pengajuan = convertDatetoStringFormat(tglPengajuan);
            jsonObj.id_karyawan = tempId;
            jsonObj.id_jenis_pengajuan = $("#JenisCuti").val();
            jsonObj.durasi = totalDurasi;
            jsonObj.id_approval = $("#IDApproval").val();
            jsonObj.approve_status = "PENDING";
            jsonObj.created_by = $("#NamaKaryawan").val();
            jsonObj.keterangan_pengajuan = $("#Keterangan").val();
            jsonObj.approved_by = $("#IDKywApproval").val();
            for (var i = 0, l = listDateCollection.length; i < l; i++) {
                var addDetail = {}
                var num = i + 1;
                addDetail.id_pengajuan_detail = num.toString();
                addDetail.start_date = listDateCollection[i];
                addDetail.end_date = listDateCollection[i];
                addDetail.durasi = durasi;
                detailArray.push(addDetail);
            }
            jsonObj.detail = detailArray;

            var b = JSON.stringify(jsonObj);
            var str = b.replace(/\\/g, '');
            $.ajax({
                url: "@Url.Content("~/PengajuanDOL/Create")",
                type: "POST",
                data: { body: str },
                dataType: "JSON",
                beforeSend: function () {
                    Swal.fire({
                        title: 'Processing...',
                        html: "Saving Data.",
                        allowOutsideClick: false,
                        onBeforeOpen: () => {
                            Swal.showLoading()
                        }
                    });
                },
                success: function (data) {
                    //Swal.close();
                    if (data.metaData.code == "200") {
                        id_Pengajuan = data.response.replace(/^"|"/g, '');
                        // var saldo_cuti = saldo.replace(/^"|"/g, '');
                        alert(id_Pengajuan);
                        if ($("#file").val() != "") {
                            //send File to Server
                            upload_file(id_Pengajuan);
                        } else {
                             toastr.success("Data Berhasil di Submit", "Success!", { "timeOut": 5000 });
                             var delayInMilliseconds = 1000; //1 second
                                setTimeout(function () {
                                     window.location.href = '@Url.Action("Index", "PengajuanDOL")';
                                }, delayInMilliseconds);

                            Swal.close();
                        }

                    } else {
                        Swal.close();
                        toastr.warning("Data Gagal di Submit", "Sorry!", { "timeOut": 5000 });
                    }
                },
                error: function (eventError, textStatus, errorThrown) {
                    toastr.error(formatErrorMessage(eventError, errorThrown), 'Failed!', { "timeOut": 5000 });
                }
            });
        }

        function convertDate2(data) {
            var getdate = parseInt(data.replace("/Date(", "").replace(")/", ""));
            var ConvDate = new Date(getdate);
            return ConvDate.getDate() + "/" + ConvDate.getMonth() + "/" + ConvDate.getFullYear();
        }

        function convertDatetoStringFormat(data) {
            var getDay = data.substring(0, 2);
            var getMonth = data.substring(3, 5);
            var getYear = data.substring(6,10);
            return getYear + "-" + getMonth + "-" + getDay;
        }

        function getListDetail(idPengajuan) {
             $.ajax({
                contentType: 'application/JSON; charset=utf-8',
                url: '@Url.Action("GetDataPengajuanDetailDOLByID", "PengajuanDOL")',
                type: 'POST',
                data: JSON.stringify({ "id": idPengajuan }),
                success: function (data) {
                    Swal.close();
                    if (data.metaData.code == '200') {
                        for (var i = 0, l = data.response.length; i < l; i++) {
                            obj = {}
                            //obj.Id = "ID" + ListObj.length.toString()
                            obj.StartDate = data.response[i].start_date
                            obj.EndDate = data.response[i].end_date
                            obj.WaktuDetail = data.response[i].durasi

                            ListObj.push(obj)
                            @*table.clear()
                            table.rows.add(ListObj)*@
                        }
                        //table.draw()
                        for (var i = 0; i < ListObj.length; i++) {
                            listDateCollection.push(ListObj[i].StartDate);
                        }

                        $(document).ready(function () {
                            @*$('#datepicker').datepicker({
                                multidate: true,
                                format: "yyyy-mm-dd",
                                todayHighlight: true,
                                beforeShowDay: function () {
                                    return false;
                                }
                            });*@

                            $("#datepicker").datepicker('setDates', listDateCollection);
                            $('#datepicker').datepicker('setStartDate', new Date());
                        });

                    } else {
                        toastr.warning("Gagal memuat data detail", "Sorry!", { "timeOut" : 5000});
                    }
                },
                error: function (eventError, textStatus, errorThrown) {
                    toastr.error("Gagal memuat data.", 'Failed!', { "timeOut": 5000 });
                }
             });
        }

        function getDataApproval(id_pengajuan) {
            $.ajax({
                contentType: 'application/JSON; charset=utf-8',
                url: '@Url.Action("GetDataLogApprovalByIdPengajuan", "PengajuanDOL")',
                type: 'POST',
                data: JSON.stringify({ "id": id_pengajuan }),
                success: function (data) {
                    Swal.close();
                    if (data.metaData.code == '200') {
                        $("#IDApproval").empty().append($("<option/>").val(data.response[0].id_approval).text(data.response[0].nama_approval)).val(data.response[0].id_approval);
                        getDataApprovalKaryawan(data.response[0].id_approval);
                    } else {
                        toastr.warning("Gagal memuat data ", "Sorry!", { "timeOut" : 5000});
                    }
                },
                error: function (eventError, textStatus, errorThrown) {
                    toastr.error("Gagal memuat data.", 'Failed!', { "timeOut": 5000 });
                }
             });
        }

        function getDataApprovalKaryawan(id_approval) {
            $.ajax({
                contentType: 'application/JSON; charset=utf-8',
                url: '@Url.Action("GetKaryawanApprovalByIdApproval", "MasterKaryawanApproval")',
                type: 'POST',
                data: JSON.stringify({ "id": id_approval }),
                success: function (data) {
                    Swal.close();
                    if (data.metaData.code == '200') {
                        $("#IDKywApproval").empty().append($("<option/>").val(data.response[0].id_karyawan).text(data.response[0].nama)).val(data.response[0].id_karyawan);
                    } else {
                        toastr.warning("Gagal memuat data ", "Sorry!", { "timeOut": 5000 });
                    }
                },
                error: function (eventError, textStatus, errorThrown) {
                    toastr.error('Gagal memuat data', 'Failed!', { "timeOut": 5000 });
                }
            });
        }

           @* $('#StartDate').datetimepicker({
                format: 'DD-MM-YYYY'
              });
            $('#EndDate').datetimepicker({
                useCurrent: false,
                format: 'DD-MM-YYYY'
            });
            $("#StartDate").on("change.datetimepicker", function (e) {
                $('#EndDate').datetimepicker('minDate', e.date);
            });
            $("#EndDate").on("change.datetimepicker", function (e) {
                $('#StartDate').datetimepicker('maxDate', e.date);
            });*@

        function daysDifference(firstDate, secondDate) {
            var startDay = new Date(firstDate);
            var endDay = new Date(secondDate);

            var millisBetween = endDay.getTime() - startDay.getTime();
            var days = (millisBetween / (1000 * 3600 * 24)) + 1;
            return convertDecimal(Math.abs(days),2);
        }

        function setTotalWaktuHeader() {
            var waktu = 0;
            for (var i = 0, l = ListObj.length; i < l; i++) {
                var days = daysDifference(convertDatetoStringFormat(ListObj[i].StartDate), convertDatetoStringFormat(ListObj[i].EndDate));
                waktu = waktu + (days * ListObj[i].WaktuDetail);
            }
            $("#Waktu").val(waktu);
        }

        function convertDecimal(num, dec) {

            if ((typeof num !== 'number') || (typeof dec !== 'number'))
                return false;

            var num_sign = num >= 0 ? 1 : -1;

            return (Math.round((num * Math.pow(10, dec)) + (num_sign * 0.0001)) / Math.pow(10, dec)).toFixed(dec);
        }

        function upload_file(id) {
            // Checking whether FormData is available in browser
            if (window.FormData !== undefined) {

                var fileData = new FormData($("#form-header").get(0));
                fileData.append("idPengajuan", id);
                $.ajax({
                    url: '@Url.Action("UploadFiles", "FileUpload")',
                    type: "POST",
                    enctype : "multipart/form-data",
                    contentType: false, // Not to set any content header
                    processData: false, // Not to process data
                    data: fileData,
                    success: function (result) {
                       // alert("success");
                        Swal.close();
                        toastr.success("Data Berhasil di Submit", "Success!", { "timeOut": 5000 });
                             var delayInMilliseconds = 1000; //1 second
                                setTimeout(function () {
                                     window.location.href = '@Url.Action("Index", "PengajuanDOL")';
                                }, delayInMilliseconds);

                        
                    },
                    error: function (err) {
                        Swal.close();
                        alert(err.statusText);
                    }
                });
            } else {
                Swal.close();
                alert("FormData is not supported.");
            }
        }
        function RemoveFile() {

            $('#file').val('');
            $('#file').next('label').html('Pilih File');
            $("#spanfile").text("");
        }

        $("#cancelFile").click(function () {
            document.getElementById("file").value = "";
        })

        //get file size
        function GetFileSize(fileid) {
            try {
                fileSize = 0;
                fileSize = $("#" + fileid)[0].files[0].size //size in kb
                fileSize = fileSize / 1048576; //size in mb

                return fileSize;
            }
            catch (e) {
                //alert("Error is :" + e);
            }
        }

        //get file path from client system
        function getNameFromPath(strFilepath) {
            var objRE = new RegExp(/([^\/\\]+)$/);
            var strName = objRE.exec(strFilepath);

            if (strName == null) {
                return null;
            }
            else {
                return strName[0];
            }
        }


        function checkfile() {
            var file = getNameFromPath($("#file").val());
            if (file != null) {
                var extension = file.substr((file.lastIndexOf('.') + 1));
                switch (extension) {
                    case 'pdf':
                        flag = true;
                        break;
                    default:
                        flag = false;
                }
            }
            if (flag == false) {
                $("#spanfile").text("You can upload only pdf extension file");
                return false;
            }
            else {
                var size = GetFileSize('file');
                if (size > 2) {
                    $("#spanfile").text("You can upload file up to 2 MB");
                    return false;
                }
                else {
                    $("#spanfile").text("");
                    return true;

                }
            }
        }

        function saveFile() {
            window.open("https://116.254.101.104/CutiInta/"+ detailLinkFile, '_blank');
        }
    </script>
}
